.MODEL SMALL
.STACK
.DATA
	DB   10 DUP(0)
asciitbl DB  7 DUP(0)
	DB   "$","$"
intromsg DB 0Ah,0Dh
	 DB "Type-in active-set of messages, crtl-z to clear, crtl-x to quit"
	 DB 0Ah,0Dh
	 DB "This version generates 8-bit signatures for TTERS51G.", 0Ah,0Dh
intr2    DB "Do not enter remote-output, nor Notification messages.",0Ah,0Dh
intro3   DB "FOR TERSE51: Node range = 1 - 32. Terminal range = 1 - 4."
	 DB 0Ah,0Dh
	 DB "FOR TERSE51: Signature-calc starts from latest msg on stack."
	 DB 0Ah,0Dh,0Ah,0Dh,"$"
destnode DB "Destination-node: $"
destterm DB " Destination-terminal: $"
sigtxt   DB "  SIGNATURE:$"
newline  DB 0Dh,0Ah,"$"

signature DB 0          ;8-bit signature
input     DB 0          ;binary input
header    DB 0          ;used for sig-calc

.CODE
start:
	mov ax,@DATA
	mov ds,ax
start2:
;intro message...
	mov ah,9
	lea dx,intromsg
	int 21h
start3:
;Ask for destination node....
	mov ah,9
	lea dx,destnode
	int 21h
	call getinput           ;comes back with "input", in binary...
	mov al,input
	and  al,00011111b
    ;	shl  al,1	      no. have modified hdr.  node on rhs.
    ;	shl  al,1
    ;	shl  al,1
	mov  header,al

;ask for destination terminal...
	mov ah,9
	lea dx,destterm
	int 21h
	call getinput
	mov  al,input
	dec  al                 ;as terminal no. stored as 0 - 3.
	and  al,011b
	shl  al,1
	  shl al,1	  ;modified hdr. term is bits 5-6.
	  shl al,1	       ;(notif is bit-7)
	  shl al,1
	  shl al,1
	or   header,al

;calculate the signature....
	mov al,signature
	test al,80h
	jz   sig1
	xor  al,00100001b
sig1:   xor  al,header
	shl  al,1
	mov  signature,al
	
;convert it to ascii....
	mov al,signature
	mov ah,0
	mov dx,0
	call bin2dec
	mov  BYTE PTR asciitbl+7,"$"    ;hex o/p stuffs this up.

;display result...
	mov ah,9
	lea dx,sigtxt
	int 21h
	mov ah,9
	lea dx,asciitbl
	int 21h
	  ;also display signature in hex...
	  mov bl,signature
	  mov bh,0
	  mov cl,4
	  rol bx,cl
	  mov ax,bx
	  and ax,000Fh
	    cmp al,9
	    jbe xx
	    add al,7
xx:       add al,30h
	  mov asciitbl+1," "   ;al
	  rol bx,cl
	  mov ax,bx
	  and ax,000Fh
	    cmp al,9
	    jbe yy
	    add al,7
yy:       add al,30h
	  mov asciitbl+2," "   ;al
	  rol bx,cl
	  mov ax,bx
	  and ax,000Fh
	    cmp al,9
	    jbe zz
	    add al,7
zz:       add al,30h
	  mov asciitbl+3,al
	  rol bx,cl
	  mov ax,bx
	  and ax,000Fh
	    cmp al,9
	    jbe mm
	    add al,7
mm:       add al,30h
	  mov asciitbl+4,al
	  mov BYTE PTR asciitbl+5,"h"
	  mov BYTE PTR asciitbl+6,0Ah
	  mov BYTE PTR asciitbl+7,0Dh
	  mov BYTE PTR asciitbl+8,"$"
	  mov ah,9
	  lea dx,asciitbl
	  int 21h
	jmp start3
getout:
	mov ax,4C00h
	int 21h

getinput:
	mov input,0
getinput2:
	mov ah,0
	int 16h
	cmp ax,2C1Ah    ;crtl-z
	jne notcrtlz
	mov signature,0 
	mov ah,9
	lea dx,newline
	int 21h
	pop ax          ;dump return address
	jmp start2
notcrtlz:
	cmp ax,2D18h    ;crtl-x
	jne notcrtlx
	mov ah,9
	lea dx,newline
	int 21h
	jmp getout
notcrtlx:
;test if outside range 0-9...
	cmp al,30h
	jb  below0
	cmp al,39h
	ja  above9
inrange:
;echo it to screen...
	  mov ah,0Eh
	  push ax
	  mov bx,02
	  int 10h
	  pop ax
	and al,0Fh      ;convert to binary
	 mov ah,input
	 and ah,0Fh    ;see if 2nd char already there
	 jnz second
	 ;mov cl,4
	 ;shl al,cl
	mov input,al    ;save in lo-nibble.
	jmp getinput2
second:
	mov cl,4
	shl input,cl
	mov ah,input
	 or al,ah      ;combine them
	mov input,al    ;save. ...value is in bcd format.
below0:                ;any char outside range, terminates entry
above9:                ;        /
;convert input to binary....
	mov al,input
	and al,0F0h
	mov cl,4
	ror al,cl
	mov dl,10
	mul dl          ;result --> ax
	mov bl,input
	and bl,0Fh
	add al,bl       ;now have binary value.
	mov input,al    ;       /

	ret    
;...................................................................
bin2dec PROC            ;requires binary number in dx:ax...
	lea di,asciitbl
	mov bx,di
	add di,6  ;8
	;mov BYTE PTR [di],0
	;dec di
ssss:
	mov cx,10
	div cx
	add dl,30h
sssss:
	mov [di],dl
	dec di
	mov dx,0
	cmp ax,0
	jne ssss
	mov dl," "
	cmp bx,di
	jbe sssss
	ret
bin2dec ENDP

	END  start
